#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <arpa/inet.h>

#define MAXBUF  256

int main()
{
    int ssock, csock;
    int clen, data_len;
    int fd;
    pid_t pid;
    struct sockaddr_in client_addr, server_addr;
    fd_set read_fds, tmp_fds;
    char buf[MAXBUF] = "I like you!";

    /*   */
    if ((ssock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        perror("socket error : ");
        exit(1);
    }

    /*  ɼ  */
    clen = sizeof(client_addr);

    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sin_family     = AF_INET;
    server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    server_addr.sin_port     = htons(3317);


    /*  ɼ  */
    if (bind(ssock, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
        perror("bind error : ");
        exit(1);
    }
    
    /*    */
    if (listen(ssock, 5) < 0) {
        perror("listen error : ");
        exit(1);
    }

    /*    ũ  */
    FD_ZERO(&read_fds);
    FD_SET(ssock, &read_fds);

    while(1) {

        tmp_fds = read_fds;
        
        if (select(FD_SETSIZE, &tmp_fds, (fd_set *)0, (fd_set *)0, 
                                                 (struct timeval *)0) < 1) {
            perror("select error : ");
            exit(1);
        }

        for(fd=0; fd<FD_SETSIZE; fd++)    //  ũ͸ ϳ Ȯ
        {
            if (FD_ISSET(fd, &tmp_fds)) {
                /*  ũ ̺Ʈ ߻  */
                if (fd == ssock) {
                    /* ̺Ʈ ߻  ũͰ    */

                    /*  ó */
                    csock = accept(ssock, (struct sockaddr *)&client_addr, &clen);

                    /*  ũͿ ߰ */
                    FD_SET(csock, &read_fds);
                    printf("ο Ŭ̾Ʈ %d  ũ \n", csock, csock);
                } else {
                    /* ̺Ʈ ߻  ũͰ Ŭ̾Ʈ   */

                    /* ش  ũ κ ͸ д´ */
                    data_len = read(fd, buf, MAXBUF);
                    if (data_len > 0) {
                        /* ش  ũ Ͽ ͸  */
                        write(fd, buf, MAXBUF);
                    } else if (data_len == 0){
                        /* Ͱ    ش  Ѵ */
                        close(fd);
                        FD_CLR(fd, &read_fds);

                        printf("Ŭ̾Ʈ %d  ũ  \n", fd);
                    } else if (data_len < 0) {
                        /*  ϵ   ó */
                        perror("read error : ");
                        exit(1);
                    } /* if */
                } /* if */
            } /* if */
        } /* for */
    } /* while */

    return 0;
}

