// OverlapCompletion.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>
#include <winsock2.h>

#pragma comment( lib, "ws2_32.lib" )

// 
HINSTANCE	g_hInst;
HWND		g_hWnd;
SOCKET		g_hSocket;

// WSAAsyncSelect  Ʈũ ̺Ʈ ߻ Post ޽
#define WM_MYSOCKET_NOTIFY		(WM_APP+0)

// ڽ Ʈ ̵
#define IDC_CONNECT				0
#define IDC_SEND				1
#define IDC_CLOSE				2
#define IDC_RECV				3

//   Ʈ ޾ ͳ ּ ü ϴ Լ
BOOL GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}


void OnBtConnect()
{
	SOCKADDR_IN des_addr;				//  ּ ü
	
	// TCP  Ѵ.
	//g_hSocket = socket( AF_INET, SOCK_STREAM, 0 );
	g_hSocket = WSASocket( AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED );
	if( g_hSocket == INVALID_SOCKET )
	{
		MessageBox( g_hWnd, "  ", "˸", MB_OK );
		return;
	}

	// ϰ ϴ ּҿ  ּ ü ´.
	if( !GetSockAddr("localhost", 6565, &des_addr ) )
	//if( !GetSockAddr("210.118.56.56", 6565, &des_addr ) )
	{
		MessageBox( g_hWnd, "ּ  ", "˸", MB_OK );
		return;
	}
	
	// ޽  non-blocking   Ѵ.
	// g_hSocket Ʈũ ̺Ʈ (FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE)
	// ߻ g_hWnd  WM_MYSOCKET_NOTIFY ޽ Postϰ ȴ.
	WSAAsyncSelect( g_hSocket, g_hWnd, WM_MYSOCKET_NOTIFY, 
		FD_CONNECT|FD_READ|FD_WRITE|FD_CLOSE );

	//  Ѵ.
	if( connect( g_hSocket, (PSOCKADDR)&des_addr, sizeof(des_addr)) == SOCKET_ERROR ) 
	{
		int err = WSAGetLastError();
		if( err != WSAEWOULDBLOCK )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
			closesocket(g_hSocket);
		}
		
		if( err == WSAEPROTONOSUPPORT )
		{
			MessageBox( g_hWnd, " ", "˸", MB_OK );
		}
	}
}

typedef struct _MYOVERLAPPED : public WSAOVERLAPPED
{
	SOCKET hSocket;
	WSABUF wsabuf;
}MYOVERLAPPED;

void CALLBACK SendCompletionROUTINE(
  IN DWORD dwError,
  IN DWORD cbTransferred,
  IN LPWSAOVERLAPPED lpOverlapped,
  IN DWORD dwFlags
)
{
	MYOVERLAPPED* myov = (MYOVERLAPPED*)lpOverlapped;

	MessageBox( g_hWnd, "  ", "˸", MB_OK );

	delete [] myov->wsabuf.buf;
	delete myov;
}

void OnBtSend()
{
	int nError;
	DWORD dwSent;
	
	//  ü غ 
	MYOVERLAPPED* myov = new MYOVERLAPPED;

	myov->hSocket = g_hSocket;
	
	//    غ
	myov->wsabuf.buf = new char[1000];
	ZeroMemory( myov->wsabuf.buf, 1000 );
	strcpy( myov->wsabuf.buf, "hello" );
	myov->wsabuf.len = 6;

	//   õѴ.
	nError = WSASend( g_hSocket, &myov->wsabuf, 1, &dwSent, 0, myov, SendCompletionROUTINE );

	if( nError == 0 )
	{
		// ѹ Ⱑ Ǿ.
		MessageBox( g_hWnd, "ѹ  ", "˸", MB_OK );
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		//   ۵Ǿ  ϷǸ Ϸ Լ ȣ ̴.
		//  I/O Լ ȣ      ־
		// Ϸ Լ ȣ   ִ.
		SleepEx( INFINITE, TRUE );
		return;
	}
	else
	{
		//  .
		closesocket( g_hSocket );
	}
	
	//  ü ı
	delete [] myov->wsabuf.buf;
	delete myov;
}

void OnBtClose()
{
	shutdown( g_hSocket, 1 );
}


void CALLBACK RecvCompletionROUTINE(
  IN DWORD dwError,
  IN DWORD cbTransferred,
  IN LPWSAOVERLAPPED lpOverlapped,
  IN DWORD dwFlags
)
{
	MYOVERLAPPED* myov = (MYOVERLAPPED*)lpOverlapped;

	MessageBox( g_hWnd, myov->wsabuf.buf, " ޱ ", MB_OK );

	delete [] myov->wsabuf.buf;
	delete myov;
}

void OnBtRecv()
{
	int nError;
	DWORD dwFlags = 0;
	DWORD dwRead;
	
	//  ü غ 
	MYOVERLAPPED* myov = new MYOVERLAPPED;

	myov->hSocket = g_hSocket;
	
	//    غ
	myov->wsabuf.buf = new char[1000];
	ZeroMemory( myov->wsabuf.buf, 1000 );
	myov->wsabuf.len = 1000;

	//  ޱ õѴ.
	nError = WSARecv( g_hSocket, &myov->wsabuf, 1, &dwRead, &dwFlags, myov, RecvCompletionROUTINE );
	if( nError == 0 )
	{
		// ѹ ޱⰡ Ǿ.
		MessageBox( g_hWnd, myov->wsabuf.buf, "ٷ ޱ ", MB_OK );
	}
	else
	if( nError == SOCKET_ERROR && WSAGetLastError() == WSA_IO_PENDING )
	{
		//  ޱⰡ ۵Ǿ  ϷǸ Ϸ Լ ȣ ̴.
		//  I/O Լ ȣ      ־
		// Ϸ Լ ȣ   ִ.
		SleepEx( INFINITE, TRUE );
		return;

	}
	else
	{
		// ޱ .
		closesocket( g_hSocket );
	}

	//  ü ı
	delete [] myov->wsabuf.buf;
	delete myov;
}

void OnReceive()
{
	OnBtRecv();
}

// Ʈũ ̺Ʈ ߻ ȣǴ Լ
void OnMySocketNotify( WPARAM wParam, LPARAM lParam )
{
    int nEvent = WSAGETSELECTEVENT( lParam );
    int nError = WSAGETSELECTERROR( lParam );

	switch( nEvent )
	{
	case FD_CONNECT:
		if( nError == 0 )
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		else
		{
			closesocket( g_hSocket );
			MessageBox( g_hWnd, " !", "˸", MB_OK );
		}
		break;
	case FD_WRITE:
		// ۸ Ⱑ Ǿ  ̴.
		break;
	case FD_READ:
		OnReceive();
		break;
	case FD_CLOSE:
		closesocket( g_hSocket );
		MessageBox( g_hWnd, " !", "˸", MB_OK );
		break;
	}
}

//  ν
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE: //   ư Ʈ 
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 10, 80, 20, hwnd, (HMENU)IDC_CONNECT, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 40, 80, 20, hwnd, (HMENU)IDC_SEND, g_hInst, NULL );
		CreateWindow( "BUTTON", "", WS_CHILD|WS_VISIBLE,
						10, 70, 80, 20, hwnd, (HMENU)IDC_CLOSE, g_hInst, NULL );
		CreateWindow( "BUTTON", "ޱ ȣ", WS_CHILD|WS_VISIBLE,
						10, 100, 80, 20, hwnd, (HMENU)IDC_RECV, g_hInst, NULL );
		break;

	case WM_COMMAND:
		{
		//  ư  ̺Ʈ ڵ鸵 Ѵ.
		WORD code = HIWORD(wParam);
		WORD control_id = LOWORD(wParam);
		if( code == BN_CLICKED )
		{
			switch( control_id )
			{
			case IDC_CONNECT :
				OnBtConnect();
				break;
			case IDC_SEND :
				OnBtSend();
				break;
			case IDC_RECV :
				OnBtRecv();
				break;
			case IDC_CLOSE :
				OnBtClose();
				break;
			}
		}
		}
		break;

	case WM_MYSOCKET_NOTIFY:
		// Ʈũ ̺Ʈ ߻Ͽ.
		OnMySocketNotify( wParam, lParam );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wParam,lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInstance;

	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "Overlapped Completion Client";
	
	RegisterClass(&wc);
	
	g_hWnd = CreateWindow("Overlapped Completion Client",
						"Overlapped Completion Client",
						WS_OVERLAPPEDWINDOW|WS_BORDER,
						100,
						50,
						300,
						200,
						NULL,
						NULL,
						hInstance,
						NULL);

	ShowWindow(g_hWnd, nCmdShow);
	UpdateWindow(g_hWnd);


    //  ʱȭ ؾ߸   ִ.
	WSADATA   wsaData;
    if( WSAStartup( MAKEWORD(2,2), &wsaData) != 0)
    {
        MessageBox( g_hWnd, " ʱȭ !", "˸", MB_OK );
		return 0;
    }

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//    cleanup Լ ȣ ؾ Ѵ.
    closesocket(g_hSocket);
    WSACleanup();

	return 0;
}