// ChatClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChatClient.h"
#include "ChatClientDlg.h"
#include "CreateChattingRoom.h"
#include "packetCode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SERVER_IP "211.189.19.210"
#define SERVER_PORT "2005"
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatClientDlg dialog

CChatClientDlg::CChatClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatClientDlg)
	m_ipAddr = _T("");
	m_nickName = _T("");
	m_portNum = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChatClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatClientDlg)
	DDX_Control(pDX, IDC_CREATE_ROOM, m_createRoom);
	DDX_Control(pDX, IDC_USER_LIST, m_userList);
	DDX_Control(pDX, IDC_CONNECT, m_connect);
	DDX_Control(pDX, IDC_ROOM_LIST, m_roomList);
	DDX_Text(pDX, IDC_IPADDR, m_ipAddr);
	DDV_MaxChars(pDX, m_ipAddr, 15);
	DDX_Text(pDX, IDC_NICKNAME, m_nickName);
	DDV_MaxChars(pDX, m_nickName, 12);
	DDX_Text(pDX, IDC_PORTNUM, m_portNum);
	DDV_MaxChars(pDX, m_portNum, 6);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChatClientDlg, CDialog)
	//{{AFX_MSG_MAP(CChatClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_MESSAGE(WM_RECEIVE_DATA,OnReceive)
	ON_BN_CLICKED(IDC_CREATE_ROOM, OnCreateRoom)
	ON_NOTIFY(NM_DBLCLK, IDC_ROOM_LIST, OnDblclkRoomList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatClientDlg message handlers

BOOL CChatClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// ʱȭ κ
	pChatDlg=NULL;
	m_pClientSock=0;
	listCount=0;

	m_ipAddr=SERVER_IP;
	m_portNum=SERVER_PORT;
	UpdateData(FALSE);

	//   ʾǷ, ȭ  ư Ȱȭ Ų.
	m_createRoom.EnableWindow(FALSE);

	InitRoomList();
	m_roomList.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChatClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CChatClientDlg::InitRoomList()
{
	LV_COLUMN lvcolumn;
	
	char *list[3]={"ȣ","ȭ ","ο"};
	int width[3]={50,350,60};
	
	for(int i=0;i<3;i++)
	{
		lvcolumn.mask=LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
		lvcolumn.fmt=LVCFMT_CENTER;
		lvcolumn.pszText=list[i];
		lvcolumn.iSubItem=i;
		lvcolumn.cx=width[i];
		m_roomList.InsertColumn(i,&lvcolumn);
	}
}

void CChatClientDlg::resetLobbyData()
{
	listCount=0;
	m_roomList.DeleteAllItems();
	m_userList.ResetContent();
}

void CChatClientDlg::OnConnect() 
{
	UpdateData(TRUE);

	// Ѵ.
	m_pClientSock=new CClientSocket;
	m_pClientSock->Create();
	// Ѵ.
	m_pClientSock->Connect(m_ipAddr,atoi(m_portNum));
	m_pClientSock->SetWnd(this->m_hWnd);	

	// ư Ȱȭ Ų.
	m_connect.EnableWindow(FALSE);
	//ȭ  ư Ȱȭ Ų.
	m_createRoom.EnableWindow(TRUE);
}


void CChatClientDlg::OnReceive(UINT wParam,LONG lParam)
{
	int code=0;
	int size=0;
	char buf[MAX_SOCKETBUF_SIZE];

	memset(&buf,0x00,MAX_SOCKETBUF_SIZE);

	m_pClientSock->Receive(buf,2);            //Ŷ  о
	memcpy(&code,&buf[0],sizeof(code));
	memset(&buf,0x00,sizeof(code));

	m_pClientSock->Receive(buf,2);            //  о.
	memcpy(&size,&buf[0],sizeof(size));
	memset(&buf,0x00,sizeof(size));

	m_pClientSock->Receive(buf,size);         // ̸ŭ  о
	
	switch(code)
	{
	case S2C_SND_CONNECT_OK:
		AfxMessageBox("  Ͽϴ.");
		m_pClientSock->sendPacket(C2S_REQ_LOBBY_DATA,m_nickName);
		break;
	case S2C_REP_LOBBY_ROOM:
		char *strNum,*strName,*strUserCount;
		strNum=strtok(buf,"|");
		strName=strtok(NULL,"|");
		strUserCount=strtok(NULL,"|");
		insertChatRoom(strNum,strName,strUserCount);
		break;
	case S2C_REP_LOBBY_USER:
		m_userList.AddString(buf);
		break;
	case S2C_REP_CREATE_ROOM:
		if(atoi(buf)>0)		//ȭ ߴٸ..
			m_pClientSock->sendPacket(C2S_IS_POSSIBLE_JOIN_ROOM,buf);
		break;
	case S2C_REP_POSSIBLE_JOIN_ROOM:
		joinRoom(atoi(buf),m_nickName);
		break;
	case S2C_REP_IMPOSSIBLE_JOIN_ROOM:
		AfxMessageBox("ȭ ο    Ұ մϴ.");
		break;
	case S2C_ADD_USER_IN_ROOM:
		pChatDlg->insertUser(buf);
		break;
	case S2C_REJECT_JOIN_ROOM:
		AfxMessageBox("ȭ ο    Ұ մϴ.");
		pChatDlg->CloseWnd();
		break;
	case S2C_SND_DELUSER_IN_LOBBY:
		int nIndex;
		if((nIndex=m_userList.FindString(nIndex,buf)) != LB_ERR)
		{
			m_userList.DeleteString(nIndex);
		}
		break;
	case S2C_SND_CHAT_MSG:
		pChatDlg->insertMsg(buf);
		break;
	case S2C_SND_DELUSER_IN_ROOM:
		pChatDlg->delUser(buf);
		break;
	case S2C_REP_QUIT_ROOM:
		pChatDlg->CloseWnd();
		resetLobbyData();
		m_pClientSock->sendPacket(C2S_REQ_LOBBY_DATA,m_nickName);
		break;
	}
}

void CChatClientDlg::insertChatRoom(char* roomNum,char* roomName,char* userCount)
{
	LV_ITEM lvitem;

	lvitem.mask=LVIF_TEXT;
	lvitem.iItem=listCount;
	lvitem.iSubItem=0;
	lvitem.pszText=roomNum;
	m_roomList.InsertItem(&lvitem);
			
	lvitem.iItem=listCount;
	lvitem.iSubItem=1;
	lvitem.pszText=roomName;
	m_roomList.SetItem(&lvitem);
			
	lvitem.iItem=listCount;
	lvitem.iSubItem=2;
	lvitem.pszText=userCount;
	m_roomList.SetItem(&lvitem);

	listCount++;					//ȭ Ʈ ī͸ ÷ش.
}

void CChatClientDlg::OnCreateRoom() 
{
	CCreateChattingRoom mDlg;

	if(mDlg.DoModal()==IDOK)
		m_pClientSock->sendPacket(C2S_REQ_CREATE_ROOM,mDlg.m_createName);
}

void CChatClientDlg::joinRoom(int roomNum,CString userName)
{
	pChatDlg=new CDlgChattingRoom(roomNum,userName,this);
	pChatDlg->DoModal();
}

void CChatClientDlg::OnDblclkRoomList(NMHDR* pNMHDR, LRESULT* pResult) 
{
    POSITION pos = m_roomList.GetFirstSelectedItemPosition();

    int selIndex;
    CString strRoomNum;

    if(pos!=NULL)
    {
        selIndex = m_roomList.GetNextSelectedItem(pos);
        strRoomNum = m_roomList.GetItemText(selIndex, 0); 
		m_pClientSock->sendPacket(C2S_IS_POSSIBLE_JOIN_ROOM,strRoomNum);
    }
	*pResult = 0;
}
