#define NICKNAME_SIZE 12
#define IPADDR_SIZE 15

#define USER_EMPTY 0
#define USER_IN_LOBBY 1
#define USER_IN_CHATROOM 2
typedef struct _UserData
{
	int fd;
	char nickName[NICKNAME_SIZE+1];
	int roomNum;
	int state;	
}User;

#define ROOMNAME_SIZE 100
#define MAXUSER_IN_ROOM 10

#define ROOM_CLOSED 0
#define ROOM_OPENED 1

typedef struct _RoomData
{
	int roomNum;
	char roomName[ROOMNAME_SIZE+1];
	int userIndex[MAXUSER_IN_ROOM];
	int userCount;
	int state;
}Room;

void initData();
void resetUser(int index);
void resetRoom(int index);

int procData(int fd);
void newUserSetting(int fd,char* nickName);		//ο  
void sendRoomData(int fd);						//ȭ  
void sendUserData(int fd);						//   
void sendNewuserInLobby(int fd);				//  ڿ ο  ˸
void sendNewRoomData(int roomNum);				//  ȭ  ڿ ˸
void delUserInLobby(int fd);					//ǿ ִ ڿ ǿ  ڸ ˸
void sendChatMsg(int fd,char* chatMsg);			//ȭ ޽ 
void quitRoom(int fd);							//ȭ濡 .

void sendPacket(int fd,int code,char* data);
int disconnect(int fd);

int init_signal_handler();
int get_listener_fd(int port);
int get_connect_fd();
int setup_sigio(int fd);
void setup_sigio_listeners(int fd);
void do_sigio(int signo);
void do_sigpipe(int signo);

